From qjackson@direct.caSat Nov 11 21:04:16 1995
Date: Sat, 11 Nov 1995 12:13:30 -0800
From: qjackson@direct.ca
To: "MARY L. EVANS" <mlevans@hamlet.uncg.edu>
Subject: Re: TP in QB 4.5?

At 02:22 P.M. 11/11/95 -0500, you wrote:

>I have a question...I'm trying to write a file in QB 4.5 that opens a msg 
>base for iniquity bbs that was written in Turbo Pascal 7.0. I have the 
>file structures but cannot figure out why it won't work. I will attach my 
>basic source and the tp file structures in the following message..any 
>help would be VERY much appreciated, i will send you the source of the 
>finished program and give you credit everytime it is run. Thanks Alot!

Mary:

Okay, I seem to have fixed it.  I've tested in under QBASIC.

I included a little loop that prints out some pertinent information from
each record (TO, FROM, SUBJECT, stuff like that).

Hope I've been of some help.

I've attached the .BAS file....




  [ Part 2: "Attached Text" ]

'   This file has been corrected by Quinn Tyler Jackson
'   ---------------------------------------------------
'
'   11 NOV 95


DECLARE FUNCTION FS$ (stfix$)

'   tNetAddressRec = record
'      Zone          : Word;
'      Net           : Word;
'      Node          : Word;
'      Point         : Word;
'   end;

'  tMsgInfoRec = record
'      UserNum       : Word;
'      Alias         : String[36];
'      Realname      : String[36];
'      Name          : String[36];
'      UserNote      : String[40];
'      Address       : tNetAddressRec;
'  end;
'
'   pMsgHeaderRec = ^tMsgHeaderRec;
'   tMsgHeaderRec = record
'      msgFrom       : tMsgInfoRec;
'      msgTo         : tMsgInfoRec;
'      Pos           : LongInt;
'      Size          : Word;
'      Date          : LongInt;
'      Status        : set of tMsgStatusFlag;
'      Replies       : Word;
'      Subject       : String[40];
'      NetFlag       : set of tNetAttribFlag;
'      SigPos        : Word;
'      incFile       : Word;
'      msgTag        : Word;
'      Reserved      : array[1..54] of Byte;
'   end;

'   You didn't have this TYPE in your original file
TYPE NetAddressRec
	Zone    AS INTEGER
	Net     AS INTEGER
	Node    AS INTEGER
	'   Point needs two tt's to account for the native POINT keyword
	'   in BASIC
	Pointt  AS INTEGER
END TYPE

TYPE MsgInfoRec
  UserNum AS INTEGER
  Alias1 AS STRING * 37
  Realname AS STRING * 37
  Name1 AS STRING * 37
  UserNote AS STRING * 41
  ' Address is NetAddressRec, not INTEGER
  Address  AS NetAddressRec
END TYPE

DIM UserRec AS MsgInfoRec

TYPE MsgHdrRec
  msgTo AS MsgInfoRec
  msgFrom AS MsgInfoRec
  posi AS LONG
  Size AS INTEGER
  Date AS LONG
  ' Status is STRING*1, not INTEGER, because it is a bit field
  Status AS STRING * 1
  Replies AS INTEGER
  Subject AS STRING * 41
  NetFlag AS INTEGER
  SigPos AS INTEGER
  incFile AS INTEGER
  msgTag AS INTEGER
  Reserved AS STRING * 54
END TYPE

DIM PascalRec AS MsgHdrRec

CLS

OPEN "c:\tmp\NEWAREA.HDR" FOR BINARY AS #1
NumberOfRecords = LOF(1) \ LEN(PascalRec)

FOR i = 1 TO NumberOfRecords

	GET #1, , PascalRec
	PRINT "TO:"; FS$((PascalRec.msgTo.Realname));
	PRINT " ("; FS$((PascalRec.msgTo.Alias1)); ")";
	PRINT " {"; FS$((PascalRec.msgTo.Name1)); "}";
	PRINT " ["; FS$((PascalRec.msgTo.UserNote)); "]"

	PRINT "FROM:"; FS$((PascalRec.msgFrom.Realname));
	PRINT " ("; FS$((PascalRec.msgFrom.Alias1)); ")";
	PRINT " {"; FS$((PascalRec.msgFrom.Name1)); "}";
	PRINT " ["; FS$((PascalRec.msgFrom.UserNote)); "]"

	PRINT "SUBJECT:"; FS$((PascalRec.Subject))
	PRINT "---------------------------------------"

NEXT i

'   I made this simpler, too
FUNCTION FS$ (stfix$)
	FS$ = MID$(stfix$, 2, ASC(stfix$))
END FUNCTION


  [ Part 3: "Attached Text" ]

--
Voting Member: Editors' Association of Canada ||  Quinn Tyler Jackson
Contributing Editor:       Tickled by Thunder ||    (aka 'Jamshid')
Programmer:        PowerBASIC, C++/C, ['LPM'$ |+---------------------
Speak/Write:           English, French, Farsi ||  qjackson@direct.ca
